(define (problem brownies-default)
    (:domain brownies)
    (:objects)
    (:init
		 
		 (= (objectId cupboard_tr) 1)
		 (= (objectId cupboard_tl) 2)
		 (= (objectId cupboard_br) 3)
		 (= (objectId cupboard_tm) 4)
		 (= (objectId fridge) 5)
		 (= (objectId oven) 6)
		 (= (objectId egg_box) 7)
		 (= (objectId brownie_box) 8)
		 (= (objectId drawer) 9)
		 (= (objectId egg_shell) 10)
		 (= (objectId cupboard_bl) 11)
		 (= (objectId oil_bottle) 12)
		 (= (objectId butter_spray_can) 13)
		 (= (objectId garbage) 14)
		 (= (objectId brownie_bag) 15)
		 (= (objectId croutons_bag) 16)
		 (= (objectId measuring_cup_s) 17)
		 (= (objectId measuring_cup_l) 18)
		 (= (objectId oil_bottle_cap) 19)
		 (= (objectId baking_pan) 20)
		 (= (objectId bowl) 21)
		 (= (objectId whisk) 22)
		 (= (objectId fork) 23)
		 (= (objectId spoon) 24)
		 (= (objectId counter) 25)
		 (= (objectId sink) 26)
		 (= (objectId towel) 27)
		 (= (objectId board) 28)
		 (= (objectId knife) 29)
		 (= (objectId butter_spray_cap) 30)
		 (= (objectId scissors) 31)
		 (= (objectId spatula) 32)
 		 (= (objectId empty_egg_shell) 33)
 		 (= (objectId paper_towel) 34)
 		 (= (objectId counter_place) 35)
 		 (= (objectId fridge_place) 36)
 		 (= (objectId egg) 37)
  		 (= (objectId open_egg_shell) 38)
  		 (= (objectId water) 39)
  		 (= (objectId tap) 40)
  		 (= (objectId brownie_mix) 41)
  		 (= (objectId oil) 42)
  		 (= (objectId butter) 43)
  		 (= (objectId dough) 44)
  		 (= (objectId hands) 45)
		 
		 
		 "", "take", "put", "turn_on", "fill", "open", "close", "stir", "shake", "clean", "other"
		 (= (actionId walk) 0)
		 (= (actionId take) 1)
		 (= (actionId put) 2)
		 (= (actionId turn_on) 3)
		 (= (actionId fill) 5)
		 (= (actionId open) 6)
		 (= (actionId close) 7)
		 (= (actionId stir) 8)
		 (= (actionId shake) 9)
		 (= (actionId clean) 10)
		 (= (actionId other) 11)
		
		;combined objects
		;combined objects
		(= (first measuring_cup_s&measuring_cup_l) measuring_cup_s)
		(= (second measuring_cup_s&measuring_cup_l) measuring_cup_l)

		(= (first butter_spray_can&oil_bottle) butter_spray_can)
		(= (second butter_spray_can&oil_bottle) oil_bottle)

		(= (first oil_bottle&oil_bottle_cap) oil_bottle)
		(= (second oil_bottle&oil_bottle_cap) oil_bottle_cap)		

		(= (first  oil_bottle&measuring_cup_s) oil_bottle)
		(= (second  oil_bottle&measuring_cup_s)  measuring_cup_s)

		(= (first brownie_box&brownie_bag) brownie_box)
		(= (second  brownie_box&brownie_bag) brownie_bag)

		(= (first baking_pan&bowl) baking_pan)
		(= (second  baking_pan&bowl) bowl)
		
		(= (first brownie_box&whisk) brownie_box)
		(= (second  brownie_box&whisk) whisk)
		
		(= (first fork&spoon) fork)
		(= (second  fork&spoon) spoon)
		
		(fill-triple brownie_mix brownie_bag bowl)
		(fill-triple butter butter_spray_can baking_pan)
		(fill-triple dough bowl baking_pan)
		(fill-triple egg open_egg_shell bowl)
		(fill-triple oil measuring_cup_s bowl)
		(fill-triple oil oil_bottle measuring_cup_s)
		(fill-triple water measuring_cup_l bowl)
		(fill-triple water tap measuring_cup_l)
		
;grep "(take \|(put " Data/*.txt | cut -d"," -f3 | sort | uniq | sed 's/put/take/' | sed 's/take/take-pair/' | sort | uniq
		(take-pair egg_shell egg_box)
		(take-pair egg_shell counter)
		(take-pair empty_egg_shell sink)
		(take-pair empty_egg_shell garbage)
		(take-pair empty_egg_shell counter)
		(take-pair empty_egg_shell brownie_box)
		(take-pair empty_egg_shell measuring_cup_l)
		(take-pair baking_pan board)
		(take-pair baking_pan counter)
		(take-pair baking_pan cupboard_bl)
		(take-pair baking_pan oven)
		(take-pair baking_pan&bowl counter)
		(take-pair board counter)
		(take-pair bowl counter)
		(take-pair bowl cupboard_tm)
		(take-pair bowl cupboard_tr)
		(take-pair bowl sink)
		(take-pair brownie_bag brownie_box)
		(take-pair brownie_bag counter)
		(take-pair brownie_bag sink)
		(take-pair brownie_bag garbage)
		(take-pair brownie_box garbage)
		(take-pair brownie_box counter)
		(take-pair brownie_box cupboard_br)
		(take-pair brownie_box cupboard_tl)
		(take-pair brownie_box cupboard_tm)
		(take-pair brownie_box sink)
		(take-pair brownie_box&brownie_bag sink)
		(take-pair brownie_box&whisk counter)
		(take-pair butter_spray_can counter)
		(take-pair butter_spray_can cupboard_bl)
		(take-pair butter_spray_can cupboard_br)
		(take-pair butter_spray_can&oil_bottle counter)
		(take-pair butter_spray_can&oil_bottle cupboard_br)
		(take-pair butter_spray_cap counter)
		(take-pair croutons_bag counter)
		(take-pair croutons_bag cupboard_br)
		(take-pair egg_box counter)
		(take-pair egg_box fridge)
		(take-pair fork bowl)
		(take-pair fork counter)
		(take-pair fork drawer)
		(take-pair fork sink)
		(take-pair fork baking_pan)
		(take-pair fork&spoon bowl)
		(take-pair fork&spoon sink)
		(take-pair knife counter)
		(take-pair knife drawer)
		(take-pair measuring_cup_l counter)
		(take-pair measuring_cup_l cupboard_tr)
		(take-pair measuring_cup_l sink)
		(take-pair measuring_cup_s counter)
		(take-pair measuring_cup_s cupboard_tr)
		(take-pair measuring_cup_s sink)
		(take-pair measuring_cup_s&measuring_cup_l counter)
		(take-pair oil_bottle counter)
		(take-pair oil_bottle cupboard_bl)
		(take-pair oil_bottle cupboard_br)
		(take-pair oil_bottle sink)
		(take-pair oil_bottle&measuring_cup_s counter)
		(take-pair oil_bottle&oil_bottle_cap counter)
		(take-pair oil_bottle_cap counter)
		(take-pair paper_towel counter)
		(take-pair paper_towel fridge_counter)
		(take-pair paper_towel sink)
		(take-pair paper_towel garbage)
		(take-pair scissors counter)
		(take-pair scissors drawer)
		(take-pair spatula bowl)
		(take-pair spatula drawer)
		(take-pair spoon bowl)
		(take-pair spoon drawer)
		(take-pair spoon sink)
		(take-pair towel counter)
      (take-pair towel fridge_counter)
		(take-pair whisk baking_pan)
		(take-pair whisk bowl)
		(take-pair whisk counter)
		(take-pair whisk drawer)
		(take-pair whisk sink)

		(= (open-of egg_shell) open_egg_shell)
		(= (empty-of open_egg_shell) empty_egg_shell)
		(is-in egg open_egg_shell)
		
		
		(in water tap)
		(in brownie_mix brownie_bag)
		(in oil oil_bottle)
		(in butter butter_spray_can)
		(is-clean hands)
		(is-clean bowl)
		(not (is-clean spoon))

		;fluents
		(= (at) counter_place)
		(= (is-at-num egg_shell egg_box) 2)
		(= (is-at-num paper_towel fridge_counter) 2)
		
		
		; object location
		(= (is-at egg_box) fridge)
		(= (is-at brownie_bag) brownie_box)
		(= (is-at croutons_bag) cupboard_br)
		(= (is-at measuring_cup_s) cupboard_tr)
		(= (is-at measuring_cup_l) cupboard_tr)
		(= (is-at fork) drawer)
		(= (is-at knife) drawer)
		(= (is-at whisk) drawer)
		(= (is-at oil_bottle_cap) oil_bottle)
		(= (is-at butter_spray_cap) butter_spray_can)
		(= (is-at scissors) drawer)
		(= (is-at spoon) drawer)
		(= (is-at spatula) drawer)
		(= (is-at board) counter)
		(= (objects_taken) 0)
	(= (is-at bowl) cupboard_tr)
	(= (is-at brownie_box) cupboard_tm)
	(= (is-at oil_bottle) cupboard_br)
	(= (is-at butter_spray_can) cupboard_br)
	(= (is-at baking_pan) cupboard_bl)
	)
	
	(:goal
		finished
	)
)
