(define (domain eggs)

(:types
	take1 put1 open1 close1 takeput2 turn_on1 ctake1 cput twoobjects fill1 fill2 fill3 - object
	take2 put2  - takeput2
	twoobjects - object
	walkl - object
	part - object
   openp1 - open1
	copen1 - take1
	cofill2 - fill2
	cfill1 - object
)
	
	(:constants
      pepper_shaker&salt_shaker whisk&spatula - twoobjects
       cupboard_tr cupboard_tl cupboard_bl cupboard_br cupboard_tm fridge egg_box drawer oil_bottle garbage butter_spray_can salt_shaker pepper_shaker - open1
       salt_shaker - openp1
       cupboard_tr cupboard_tl egg_box fridge drawer cupboard_bl cupboard_br oil_bottle garbage butter_spray_can salt_shaker pepper_shaker cupboard_tm - close1
       oil_bottle drawer - closep1
       cupboard_tr cupboard_tl egg_box drawer counter bowl cupboard_bl cupboard_br stove sink pan floor plate cupboard_tm hands garbage oil_bottle butter_spray_can fridge fridge_counter - take2
       whisk open_egg_shell bowl hands fork pepper_shaker salt_shaker pan oil_bottle plate oil_bottle_cap paper_towel towel spoon butter_spray_can spatula butter_spray_cap egg_box paper_towel bowl_s - take1
       counter sink bowl cupboard_tl cupboard_br cupboard_tr cupboard_bl pan  plate drawer garbage stove floor hands fridge_counter fridge - put2
       
       whisk bowl fork  pepper_shaker salt_shaker pan oil_bottle plate oil_bottle_cap paper_towel towel spoon butter_spray_can spatula butter_spray_cap paper_towel bowl_s egg_box - put1
       fridge_place counter_place - walkl
       salt pepper oil egg butter eggs - fill1
       salt_shaker pepper_shaker oil_bottle bowl pan butter_spray_can hands - fill2
       bowl pan plate sink - fill3
       bowl pan - stir1
       bowl pan - stirp1
       fork spoon spatula whisk - stir2
       fork spoon whisk spatula - stirp2
       stove - turn_on1
       stove - turn_on1p
       stove - turn_off1
       hands pan - clean1
       paper_towel towel water - clean2
 		paper_towel egg open_egg_shell empty_egg_shell - ctake1
      empty_egg_shell - cput1
      egg_shell - copen1
      stove - turn_onp1
      egg - cfill1
      open_egg_shell - cofill2
      pan - shake1
      paper_towel egg_shell - cput1
      egg_shell - ctake1
      water oil dough pepper butter salt eggs - pfill1
		partially - part
		)
	
      	 (:functions
      	 	(is-at ?w - take1) - takeput2
      		(at) - walkl
      		(objects_taken) - (number 3)
      		(is-at-num ?what - ctake1 ?where - take2) - (number 2)
      		(in-num ?what - cfill1 ?where - fill3) - (number 2)
      		(shaken ?s - shake1) - (number 3)
      	)
	
      	(:action open
      		:parameters (?what - open1)
      ;		:duration (open (objectId ?what))
      		:precondition (and 
      			(not (is-open ?what))
      			(or 
                  (iff (= (at) fridge_place) (or 
         										(= ?what fridge)
         										(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
         										)
         			)
                  (= ?what egg_box)
               )
      			(imply (or (= ?what oil_bottle)(= ?what butter_spray_can)) (<= (objects_taken) 2)))
      		:effect (and 
      				(is-open ?what)
      				(when (= ?what oil_bottle) (and
      					(assign (is-at oil_bottle_cap) hands)
      					(increase (objects_taken) 1)
      					))
      				(when (= ?what butter_spray_can) (and
      					(assign (is-at butter_spray_cap) hands)
      					(increase (objects_taken) 1)
      					))
         			(when (= ?what bread_bag) (and
         				(assign (is-at clip) hands)
         				(increase (objects_taken) 1)
         				))
                     
      				)
            ; :observation (set_action (actionId open))
      	)
	
      	(:action open
      		:parameters (?what - copen1)
            ; :duration (open (objectId ?what))
      		:precondition (and 
      			(>= (is-at-num ?what hands) 1)
      			)
      		:effect ( and 
      			(decrease (is-at-num ?what hands) 1)
      			(increase (is-at-num (open-of ?what) hands) 1)
      		)
      		; :observation (set_action (actionId open))
      		)
	
      	; this action is usually taken while fiddling around with the packaging
      	(:action open
      		:irrational
      		:parameters (?what - openp1 ?how - part)
      		; :duration (open (objectId ?what))
      		:precondition (and 
      			(not (is-open ?what))
      			(iff (= (at) fridge_place) (or 
      										(= ?what fridge)
      										(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
      										)
      			))
      		:effect (and)
      		; :observation (set_action (actionId open))
      	)
		
      	(:action close
      		:parameters (?what - close1)
      		; :duration (close (objectId ?what))
      		:precondition (and 
      				(is-open ?what)
      				(imply (= ?what oil_bottle) (= (is-at oil_bottle_cap) hands))
      				(imply (= ?what butter_spray_can) (= (is-at butter_spray_cap) hands))
      				(iff (= (at) fridge_place) (or 
      											(= ?what fridge)
      											(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
      											)
      				))
      		:effect (and
      			(not (is-open ?what))
      			(when (= ?what oil_bottle) (and 
      				(decrease (objects_taken) 1)
      				(assign (is-at oil_bottle_cap) oil_bottle)
      				))
      			(when (= ?what butter_spray_can) (and 
      				(decrease (objects_taken) 1)
      				(assign (is-at butter_spray_cap) butter_spray_can)
      				))
			
      			)
      		; :observation (set_action (actionId close))
      	)
         
         (:action close
            :irrational
            :parameters (?what - closep1 ?how - part)
            :precondition (and 
      				(is-open ?what)
      				(imply (= ?what oil_bottle) (= (is-at oil_bottle_cap) hands))
      				(imply (= ?what butter_spray_can) (= (is-at butter_spray_cap) hands))
      				(iff (= (at) fridge_place) (or 
      											(= ?what fridge)
      											(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
      											)
      				))
      		:effect ()
      		; :observation (set_action (actionId close))
      	)

      	 (:action take
      	 	:parameters (?what - take1 ?from - take2)
       		; :duration (take (objectId ?what) (objectId ?from))
      	 	:precondition (and 
;      						(take-pair ?what ?from)
      						(not (= ?what ?from))
      						(= (is-at ?what) ?from)
      						(not (= ?from hands))
      						(or
      							(and (= bread_bag ?from) (= clip ?what))
      							(imply (exists (?o - open1) (= ?from ?o)) (is-open ?from))
      						)
      						(iff (= (at) fridge_place) (or (= ?from fridge)(= ?from fridge_counter)))
      						(<= (objects_taken) 2)
      				 	 )
      		:effect (and 
      			(assign (is-at ?what) hands)
      			(increase (objects_taken) 1)
      			(when (not (is-clean ?what)) (not (is-clean hands)))
      			)
      		; :observation (set_action (actionId take))
      	 )
	 
      	 (:action take
      	 	:parameters (?what - twoobjects ?from - take2)
       		; :duration (take (objectId (first ?what)) (objectId ?from))
      	 	:precondition (and 
      			;( take-pair ?what ?from)
      						(= (is-at (first ?what)) ?from)
      						(= (is-at (second ?what)) ?from)
      						(not (= ?from hands))
      						(imply (exists (?o - open1) (= ?from ?o)) (is-open ?from))
      						(iff (= (at) fridge_place) (or (= ?from fridge)))
      						(<= (objects_taken) 1)
      				 	 )
      		:effect (and 
      			(assign (is-at (first ?what)) hands)
      			(assign (is-at (second ?what)) hands)
      			(increase (objects_taken) 2)
      			)
      		; :observation (set_action (actionId take))
      	 )
	 
      	 (:action take
      		 :parameters (?howmany - (number 1 2) ?what - ctake1 ?from - take2)
      		 ; :duration (take (objectId ?what) (objectId ?from))
      		 :precondition (and 
      			 ;( take-pair ?what ?from)
      			 (not (= ?what ?from))
      			 (>= (is-at-num ?what ?from) ?howmany)
      			(not (= ?from hands))
      			(imply (exists (?o - open1) (= ?from ?o)) (is-open ?from))
               ( or
         			(iff (= (at) fridge_place) (or 
         							(= ?from fridge)
         							(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?from)))
         							)
         						)
                  (imply (:is-type ?from take1)(=(is-at ?from) hands))
               )
      			(<= (objects_taken) (- 3 ?howmany))
      			 )
      		 :effect (and
      			 (decrease (is-at-num ?what ?from) ?howmany)
      			 (increase (is-at-num ?what hands) ?howmany)
      			 (increase (objects_taken) ?howmany)
      			 )
      			 ;TODO: check if we need the number of objects here
      		 ; :observation (set_action (actionId take))
      		)
	 
      	 (:action put
      		 :parameters (?what - put1 ?to - put2)
      		 ; :duration (put (objectId ?what)(objectId ?to))
      		 :precondition (and 
      			;(take-pair ?what ?to)
      			 (not (= ?what ?to))
      			(= (is-at ?what) hands)
      			(imply (:is-type ?to open1) (is-open ?to))
      			(iff (= (at) fridge_place) (or (= ?to fridge) (= ?to fridge_counter)))
      			)
      		 :effect (and 
      		 		(assign (is-at ?what) ?to)
      				(decrease (objects_taken) 1)
      				)
      		; :observation (set_action (actionId put))
      	)

       	(:action put
       			:parameters (?what - twoobjects ?to - put2)
      			;TODO: check for second part of ?what
      			; :duration (put (objectId (first ?what))(objectId ?to))
       			:precondition (and
      				;(take-pair ?what ?to)
       				(= (is-at (first ?what)) hands)
       				(= (is-at (second ?what)) hands)
       				(imply (exists (?o - open1) (= ?to ?o)) (is-open ?to))
       				(iff (= (at) fridge_place) (or (= ?to fridge)))
       			)
       		 :effect (and
       		 		(assign (is-at (first ?what)) ?to)
       		 		(assign (is-at (second ?what)) ?to)
       				(decrease (objects_taken) 2)
       				)
      		; :observation (set_action (actionId put))
       			)


       (:action put
      	 :parameters (?howmany - (number 1 2)  ?what - cput1 ?to - put2)
      	 ; :duration (put (objectId ?what) (objectId ?to))
      	 :precondition (and 
      		 ;(take-pair ?what ?to)
      		 (not (= ?what ?to))
      		 (>= (objects_taken) ?howmany)
      		(>= (is-at-num ?what hands) ?howmany)
      		(imply (exists (?o - open1) (= ?to ?o)) (is-open ?to))
      		(iff (= (at) fridge_place) (or 
      						(= ?to fridge)
      						(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?to)))
      						)
      					)
      		)
      	 :effect (and 
      	 		(assign (is-at-num ?what ?to) (+ (is-at-num ?what ?to) ?howmany))
      			(assign (is-at-num ?what hands) (- (is-at-num ?what hands) ?howmany))
      			(decrease (objects_taken) ?howmany)
      			)
      	; :observation (set_action (actionId put))
      )


	
      	(:action walk
      		:parameters (?from ?to - walkl)
      		; :duration (walk (objectId ?from) (objectId ?to))
      		:precondition (and
      			(= (at) ?from)
      			(not (= ?from ?to))
      			)
      		:effect (assign (at) ?to)
      		; :observation (set_action (actionId walk))
      	)
	
	
      	(:action turn_on
      		:parameters (?what - turn_on1)
      		; :duration (turn_on (objectId ?what))
      		:precondition (and
      			(not (is-on ?what))
      			(= (at) counter_place)
      			)
      		:effect (is-on ?what)
      		; :observation (set_action (actionId turn_on))
      	) 
	
      	(:action turn_off
      		:parameters (?what - turn_off1)
      		; :duration (turn_on (objectId ?what))
      		:precondition (and
      			(is-on ?what)
      			(= (at) counter_place)
      			)
      		:effect (not (is-on ?what))
      		; :observation (set_action (actionId turn_on))
      	) 
   
      	(:action turn_on
            :irrational
      		:parameters (?what - turn_on1p  ?how - part)
      		; :duration (turn_on (objectId ?what))
      		:precondition (and
      			(not (is-on ?what))
      			(= (at) counter_place)
      			)
      		:effect ()
      		; :observation (set_action (actionId turn_on))
      	) 

      	(:action fill
      		:parameters (?what - fill1 ?from - fill2  ?to - fill3)
      		; :duration (fill (objectId ?what) (objectId ?from) (objectId ?to))
      		:precondition (and 
;      			(fill-triple ?what ?from ?to)
      			(not (= ?from ?to))
      			(or 
      				(= (is-at ?from) hands)
      				(= ?from tap)
      			)
      			(or 
      				(imply (:is-type ?to take1)(= (is-at ?to) hands))
                  ; (and (= ?to pan) (= (is-at pan) stove))
      				(and (= ?to bowl) (= (is-at bowl) counter))
      				(and (= ?to measuring_cup_s) (= (is-at measuring_cup_s) counter))
      				(and (= ?to baking_pan) (or 
      					(= (is-at baking_pan) counter)
      					(= (is-at baking_pan) board))
      				)
                  (and (=? to plate) (or 
                     (= (is-at ?to) counter)
                     (= (is-at ?to) stove)
                     ))
                  (and (= ?to pan) (or 
                     (= (is-at pan) stove)
                     (= (is-at pan) counter)
                  ))
      			)
      			(or 
      					(and ;brownie recipe
      					(= ?to baking_pan)
      ;					(in butter ?to)
      					(= ?what dough)
      					(= bowl ?from)
      					(stired ?from)
      					(in brownie_mix ?from)
      					(in water ?from)
      					(in oil ?from)
      					;(= (in-num egg ?from) 2)
                     )
                     (and ;eggs recipe
                        (= ?to pan)
                        (= ?what eggs)
                    ;    (in salt ?from)
         				;	(>= (in-num egg ?from) 1)
                     ;   (in pepper ?from)
                     ;   (stired ?from)
                     )
      				(in ?what ?from)
      			)
      		)
      		:effect (and 
      			(in ?what ?to)
      			(not (in ?what ?from))
      			(not (stired ?to))
      			(not (is-clean hands))
      			(when (and (= ?what dough) (= ?from bowl) (= ?to baking_pan)) (not (is-clean bowl)))
      			)
      		; :observation (set_action (actionId fill))
      		)
		
      		(:action fill
      			:parameters (?what - pfill1 ?from - fill2  ?to - fill3 ?how - part)
      			; :duration (fill (objectId ?what) (objectId ?from) (objectId ?to))
      			:precondition (and 
                  ; (fill-triple ?what ?from ?to)
      				(not (= ?from ?to))
      				(or 
      					(= (is-at ?from) hands)
      					(= ?from tap)
      				)
      				(or 
      					(imply (:is-type ?to take1)(= (is-at ?to) hands))
      					(and (= ?to bowl) (= (is-at bowl) counter))
      					(and (= ?to pan) (= (is-at pan) stove))
      					(and (= ?to measuring_cup_s) (= (is-at measuring_cup_s) counter))
      					(and (= ?to baking_pan) (or 
      						(= (is-at baking_pan) counter)
      						(= (is-at baking_pan) board))
      					)
                     (and (= ?to sink)(= ?from pan)(= ?what oil))
      				)
      				(or 
      					(and
      					(= ?what dough)
      					(= bowl ?from)
      					(stired ?from)
      					(in brownie_mix ?from)
      					(in water ?from)
      					(in oil ?from)
      					(= (in-num egg ?from) 2)
                     )
      					(in ?what ?from)
                     (and ;eggs recipe
                        (= ?to pan)
                        (= ?what eggs)
                        ;(in salt ?from)
         					(>= (in-num egg ?from) 1)
                     ;   (in pepper ?from)
                        (stired ?from)
                     )
                  )
                  
      			)
      			:effect (and 
      				(partially-in ?what ?to)
      				(not (stired ?to))
      				(not (is-clean hands))
      				)
      			; :observation (set_action (actionId fill))
      			)
			
			
      		(:action fill
      			:parameters (?what - cfill1 ?from - cofill2 ?to - fill3)
      			; :duration (fill (objectId ?what) (objectId ?from) (objectId ?to))
      			:precondition (and 
                  ; (fill-triple ?what ?from ?to)
      				(is-in ?what ?from)
      				(>= (is-at-num ?from hands) 1)
      				)
      			:effect (and
      				(decrease (is-at-num ?from hands) 1)
      				(increase (is-at-num (empty-of ?from) hands) 1)
      				(increase (in-num ?what ?to) 1)
      				(not (stired ?to))
      				(not (is-clean hands))
      				)
      			; :observation (set_action (actionId fill))
      			)
			
      	(:action clean
      		:parameters (?what - clean1 ?with - clean2)
      		; :duration (clean (objectId ?what) (objectId ?with))
      		:precondition (and 
      			(or
      					(imply (= ?with towel) (= (is-at ?with) hands))
      					(imply (= ?with paper_towel)(>= (is-at-num paper_towel hands) 1))
      				)
      				(not (is-clean ?what))
      				)
      		:effect (and
      			(is-clean ?what))
      		; :observation (set_action (actionId clean))
      		)
		
      		(:action clean
      			:parameters (?what - clean1 ?with - clean2 ?how - part)
      			; :duration (clean (objectId ?what) (objectId ?with))
      			:precondition (and 
      				(or
      						(imply (= ?with towel) (= (is-at ?with) hands))
      						(imply (= ?with paper_towel)(>= (is-at-num paper_towel hands) 1))
      					)
      					(not (is-clean ?what))
      					)
      			:effect (and
      				(partially-is-clean ?what))
      			; :observation (set_action (actionId clean))
      			)
		
         (:action stir
                    :parameters (?where - stir1 ?with - stir2)
                    ; :duration (stir (objectId ?where) (objectId ?with))
                    :precondition (and
                       (=(is-at ?with) hands)
                       (or
                          (=(is-at ?where) hands)
                          (=(is-at ?where) counter)
                          (and (= ?where pan) (= (is-at ?where) stove))
                       )
                       ;(not (stired ?where))
                       )
                    :effect (and
                       (stired ?where)
                       (not (is-clean hands)))
                    ; :observation (set_action (actionId stir))
                    )

         (:action stir
            :parameters (?where - stirp1 ?with - stirp2 ?how - part)
            ; :duration (stir (objectId ?where) (objectId ?with))
            :precondition (and
               (=(is-at ?with) hands)
               (or
               (=(is-at ?where) hands)
               (=(is-at ?where) counter)
               (and (= ?where pan) (= (is-at ?where) stove))
               )
               ;(not (stired ?where))
               )
            :effect (and
               (partially-stired ?where))
            ; :observation (set_action (actionId stir))
            )
		
            (:action shake
                     :parameters (?what - shake1)
                     ; :duration (shake (objectId ?what))
                     :precondition (and
                       ; (= (is-at ?what) hands)
                        (< (shaken ?what) 6))
                     :effect (increase (shaken ?what) 1)
                     ; :observation (set_action (actionId shake))
            )


      	(:action other
      		:irrational
      		:parameters ()
      		; :duration (other)
      		:precondition ()
      		:effect() 
      		; :observation (set_action (actionId other))
      	)
	
      	(:action finish
      		:irrational
      		:parameters()
      		:precondition (not finished)
      		:effect (finished)
      	)
      )
