(define (domain sandwich)

      	(:types
      		take1 put1 open1 close1 takeput2 turn_on1 ctake1 cput twoobjects fill1 fill2 fill3 - object
      		take2 put2  - takeput2
      		twoobjects - object
      		walkl - object
      		part - object
      		openp1 - open1
            closep1 - close
      		copen1 - take1
      		cofill2 - fill2
      		cfill1 - object
      	)
	
      	(:predicates
      		(is-open ?what - object)
      	)
	
      	(:constants
            jam_glass&peanut_butter_glass peanut_butter_glass&peanut_butter_glass_cap knife&spoon paper_towel&knife jam_glass&jam_glass_cap peanut_butter_glass&bread_bag - twoobjects
            cupboard_tl cupboard_tr cupboard_tm drawer fridge garbage cupboard_bl peanut_butter_glass jam_glass - open1
            bread_bag drawer peanut_butter_glass - openp1
            bread_bag - closep1
            paper_towel - cput1
            bread - cfput1
            peanut_butter - pfill1
            cupboard_tr cupboard_tl cupboard_tm cupboard_bl bread_bag drawer fridge peanut_butter_glass jam_glass garbage - close1
            bread_bag clip plate knife jam_glass jam_glass_2 peanut_butter_glass peanut_butter_glass_cap jam_glass_cap spoon bread board - take1
            null cupboard_tl hands bread_bag cupboard_tr counter drawer fridge plate sink fridge_counter peanut_butter_glass jam_glass board - take2
            bread_bag clip plate knife jam_glass_2 jam_glass peanut_butter_glass_cap peanut_butter_glass jam_glass_cap knife jam_glass_cap spoon board - put1
            counter plate cupboard_tl fridge sink fridge_counter board - put2
            counter_place fridge_place - walkl
            peanut_butter jam - fill1
            jam - pfill1
            peanut_butter_glass jam_glass - fill2
            bread - fill3
            ;bread_1&bread_2 - cut1
      		paper_towel bread sandwich cut_sandwich - ctake1
      		paper_towel bread sandwich - cput1
            hands knife - clean1
            paper_towel - clean2
            sandwich - cut1
            knife - cut2
            jam_glass - shake1
            partially - part
      		)
	
      	 (:functions
      	 	(is-at ?w - take1) - takeput2
      		(at) - walkl
      		(objects_taken) - (number 3)
      		(is-at-num ?what - ctake1 ?where - take2) - (number 2)
      		(in-num ?what - cfill1 ?where - fill3) - (number 2)
      		(shaken ?s - shake1) - (number 3)
      	)
	
      	(:action open
      		:parameters (?what - open1)
      ;		:duration (open (objectId ?what))
      		:precondition (and 
      			(not (is-open ?what))
      			(iff (= (at) fridge_place) (or 
      										(= ?what fridge)
      										(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
      										)
      			)
      			(imply (or 
                  (= ?what oil_bottle)
                  (= ?what butter_spray_can)
                  (= ?what peanut_butter_glass)
                  (= ?what jam_glass)
                  (= ?what bread_bag))
                (<= (objects_taken) 2)))
      		:effect (and 
      				(is-open ?what)
      				(when (= ?what oil_bottle) (and
      					(assign (is-at oil_bottle_cap) hands)
      					(increase (objects_taken) 1)
      					))
      				(when (= ?what butter_spray_can) (and
      					(assign (is-at butter_spray_cap) hands)
      					(increase (objects_taken) 1)
      					))
         			(when (and (= ?what bread_bag) (not (is-open-partially bread_bag)) (= (is-at clip) bread_bag)) (and
         				(assign (is-at clip) hands)
         				(increase (objects_taken) 1)
         				))
         			(when (= ?what peanut_butter_glass) (and
         				(assign (is-at peanut_butter_glass_cap) hands)
         				(increase (objects_taken) 1)
         				))
         			(when (= ?what jam_glass) (and
         				(assign (is-at jam_glass_cap) hands)
         				(increase (objects_taken) 1)
         				))
                     
      				)
            ; :observation (set_action (actionId open))
      	)
	
      	(:action open
      		:parameters (?what - copen1)
            ; :duration (open (objectId ?what))
      		:precondition (and 
      			(>= (is-at-num ?what hands) 1)
      			)
      		:effect ( and 
      			(decrease (is-at-num ?what hands) 1)
      			(increase (is-at-num (open-of ?what) hands) 1)
      		)
      		; :observation (set_action (actionId open))
      		)
	
      	; this action is usually taken while fiddling around with the packaging
      	(:action open
      		:irrational
      		:parameters (?what - openp1 ?how - part)
      		; :duration (open (objectId ?what))
      		:precondition (and 
      			(not (is-open ?what))
               (imply (= ?what bread_bag) (<= (objects_taken) 1))
      			(iff (= (at) fridge_place) (or 
      										(= ?what fridge)
      										(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
      										)
      			))
      		:effect (and 
               (when (and (= ?what bread_bag) (= (is-at clip) bread_bag))
                  (and (assign (is-at clip) hands) (increase (objects_taken) 1)))
                  (is-open-partially bread_bag))
      		; :observation (set_action (actionId open))
      	)
		
      	(:action close
      		:parameters (?what - close1)
      		; :duration (close (objectId ?what))
      		:precondition (and 
      				(is-open ?what)
                  (imply (= ?what bread_bag) (or (= (is-at clip) null) (= (is-at clip) hands)))
                  (imply (= ?what peanut_butter_glass) (or (= (is-at peanut_butter_glass_cap) hands)))
                  (imply (= ?what jam_glass) (or (= (is-at jam_glass_cap) hands)))
      				(imply (= ?what oil_bottle) (= (is-at oil_bottle_cap) hands))
      				(imply (= ?what butter_spray_can) (= (is-at butter_spray_cap) hands))
      				(iff (= (at) fridge_place) (or 
      											(= ?what fridge)
      											(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
      											)
      				))
      		:effect (and
      			(not (is-open ?what))
      			(when (= ?what oil_bottle) (and 
      				(decrease (objects_taken) 1)
      				(assign (is-at oil_bottle_cap) oil_bottle)
      				))
      			(when (= ?what butter_spray_can) (and 
      				(decrease (objects_taken) 1)
      				(assign (is-at butter_spray_cap) butter_spray_can)
      				))
         		(when (and (= ?what bread_bag) (= (is-at clip) hands)) (and 
         			(decrease (objects_taken) 1)
         			(assign (is-at clip) bread_bag)
         			))
         		(when (and (= ?what jam_glass) (= (is-at jam_glass_cap) hands)) (and 
         			(decrease (objects_taken) 1)
         			(assign (is-at jam_glass_cap) jam_glass)
         			))
         		(when (and (= ?what peanut_butter_glass) (= (is-at peanut_butter_glass_cap) hands)) (and 
         			(decrease (objects_taken) 1)
         			(assign (is-at peanut_butter_glass_cap) peanut_butter_glass)
         			))
               )
      		; :observation (set_action (actionId close))
      	)
	
      	(:action close
            :irrational
      		:parameters (?what - closep1 ?how - part)
      		; :duration (close (objectId ?what))
      		:precondition (and 
      				(is-open ?what)
      				(iff (= (at) fridge_place) (or 
      											(= ?what fridge)
      											(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
      											)
      				))
      		:effect (and
      			 (is-open-partially ?what))
      		; :observation (set_action (actionId close))
      	)
   
      	 (:action take
      	 	:parameters (?what - take1 ?from - take2)
       		; :duration (take (objectId ?what) (objectId ?from))
      	 	:precondition (and 
;      						(take-pair ?what ?from)
      						(not (= ?what ?from))
      						(= (is-at ?what) ?from)
      						(not (= ?from hands))
      						(or
      							(and (= bread_bag ?from) (= clip ?what))
      							(imply (exists (?o - open1) (= ?from ?o)) (is-open ?from))
      						)
      						(iff (= (at) fridge_place) (or (= ?from fridge_counter)(= ?from fridge)))
      						(<= (objects_taken) 3)
      				 	 )
      		:effect (and 
      			(assign (is-at ?what) hands)
      			(increase (objects_taken) 1)
      			(when (not (is-clean ?what)) (not (is-clean hands)))
      			)
      		; :observation (set_action (actionId take))
      	 )
	 
      	 (:action take
      	 	:parameters (?what - twoobjects ?from - take2)
       		; :duration (take (objectId (first ?what)) (objectId ?from))
      	 	:precondition (and 
      			;( take-pair ?what ?from)
               (imply (:is-type (first ?what) ctake1) (>= (is-at-num (first ?what) ?from) 1))
      			(imply (:is-type (first ?what) take1) (= (is-at (first ?what)) ?from))
					(= (is-at (second ?what)) ?from)
					(not (= ?from hands))
					(imply (:is-type ?from open1)(is-open ?from))
					(iff (= (at) fridge_place) (or (= ?from fridge_counter) (= ?from fridge)))
					(<= (objects_taken) 1)
			 	 )
      		:effect (and 
               (when (:is-type (first ?what) take1)(assign (is-at (first ?what)) hands))
               (when (:is-type (first ?what) ctake1) (increase (is-at-num (first ?what) hands) 1))
      			(assign (is-at (second ?what)) hands)
      			(increase (objects_taken) 2)
      			)
      		; :observation (set_action (actionId take))
      	 )
	 
      	 (:action take
      		 :parameters (?howmany - (number 1 2) ?what - ctake1 ?from - take2)
      		 ; :duration (take (objectId ?what) (objectId ?from))
      		 :precondition (and 
      			 ;( take-pair ?what ?from)
      			 (not (= ?what ?from))
      			 (>= (is-at-num ?what ?from) ?howmany)
      			(not (= ?from hands))
      			(imply (exists (?o - open1) (= ?from ?o)) (is-open ?from))
      			(iff (= (at) fridge_place) (or 
      							(= ?from fridge)
                           (= ?from fridge_counter)
      							(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?from)))
      							)
      						)
      			(<= (objects_taken) (- 3 ?howmany))
      			 )
      		 :effect (and
      			 (decrease (is-at-num ?what ?from) ?howmany)
      			 (increase (is-at-num ?what hands) ?howmany)
      			 (increase (objects_taken) ?howmany)
      			 )
      			 ;TODO: check if we need the number of objects here
      		 ; :observation (set_action (actionId take))
      		)
	 
      	 (:action put
      		 :parameters (?what - put1 ?to - put2)
      		 ; :duration (put (objectId ?what)(objectId ?to))
      		 :precondition (and 
      			;(take-pair ?what ?to)
      			 (not (= ?what ?to))
      			(= (is-at ?what) hands)
      			(imply (exists (?o - open1) (= ?to ?o)) (is-open ?to))
               (or
                  (iff (= (at) fridge_place) (or (= ?to fridge_counter) (= ?to fridge)))
                  (and ; S29
                     (= ?to counter)
                     (= (at) fridge_place)
                     (= ?what bread_bag)
                  )
               )
      			)
      		 :effect (and 
      		 		(assign (is-at ?what) ?to)
      				(decrease (objects_taken) 1)
      				)
      		; :observation (set_action (actionId put))
      	)

          (:action put
                :parameters (?what - twoobjects ?to - put2)
                         ;TODO: check for second part of ?what
                         ; :duration (put (objectId (first ?what))(objectId ?to))
                :precondition (and
                            ;(take-pair ?what ?to)
                   ;(= (is-at (first ?what)) hands)
                            (imply (:is-type (first ?what) put1)(= (is-at (first ?what)) hands))
                            (imply (:is-type (first ?what) cput1)(>= (is-at-num (first ?what) hands) 1))
                            (= (is-at (second ?what)) hands)
                            (imply (:is-type ?to open1) (is-open ?to))
                             (iff (= (at) fridge_place) (or (= ?to fridge_counter)(= ?to fridge)))

                )
              :effect (and
                  (when (:is-type (first ?what) put1) (assign (is-at (first ?what)) ?to))
                  (when (:is-type (first ?what) cput1) (and (decrease (is-at-num (first ?what) hands) 1) (increase (is-at-num (first ?what) ?to) 1)))
                  (assign (is-at (second ?what)) ?to)
                  (decrease (objects_taken) 2)
               )
                      ; :observation (set_action (actionId put))
            )
            

            (:action put
           	 :parameters (?howmany - (number 1 2)  ?what - cput1 ?to - put2)
           	 ; :duration (put (objectId ?what) (objectId ?to))
           	 :precondition (and 
           		 ;(take-pair ?what ?to)
           		(not (= ?what ?to))
           		(>= (objects_taken) ?howmany)
           		(>= (is-at-num ?what hands) ?howmany)
           		(imply (exists (?o - open1) (= ?to ?o)) (is-open ?to))
           		(iff (= (at) fridge_place) (or 
           						(= ?to fridge)
                           (= ?to fridge_counter)
           						(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?to)))
           						)
           					)
           		)
           	 :effect (and 
           	 		(assign (is-at-num ?what ?to) (+ (is-at-num ?what ?to) ?howmany))
           			(assign (is-at-num ?what hands) (- (is-at-num ?what hands) ?howmany))
           			(decrease (objects_taken) ?howmany)
           			)
           	; :observation (set_action (actionId put))
           )


       (:action put
      	 :parameters (?howmany - (number 1 2)  ?what - cfput1 ?to - cfput1)
      	 ; :duration (put (objectId ?what) (objectId ?to))
      	 :precondition (and 
      		 ;(take-pair ?what ?to)
               (>= (objects_taken) ?howmany)
      		   (= (is-at-num ?what hands) ?howmany)
               (or
                  (= (is-at-num ?what plate) (- 2 ?howmany))
                  (= (is-at-num ?what board) (- 2 ?howmany))
               )
      		)
      	 :effect (and 
             (decrease (is-at-num ?what hands) 1)
             (when (= 1 ?howmany) 
                (and 
                   (assign (is-at-num ?what plate) 0)
                   (when (= (is-at-num ?what board) 1) (assign (is-at-num (fold-of ?what) board) 1))
                   (when (= (is-at-num ?what plate) 1) (assign (is-at-num (fold-of ?what) plate) 1))
                   (assign (is-at-num ?what board) 0)
               )
             )
             (when (= 2 ?howmany)
             (and (assign (is-at-num (fold-of ?what) hands) 1)
                ))
      		 (decrease (objects_taken) 1)
      	)
      	; :observation (set_action (actionId put))
      )


	
      	(:action walk
      		:parameters (?from ?to - walkl)
      		; :duration (walk (objectId ?from) (objectId ?to))
      		:precondition (and
      			(= (at) ?from)
      			(not (= ?from ?to))
      			)
      		:effect (assign (at) ?to)
      		; :observation (set_action (actionId walk))
      	)
	
	
      	(:action turn_on
      		:parameters (?what - turn_on1)
      		; :duration (turn_on (objectId ?what))
      		:precondition (and
      			(not (is-on ?what))
      			(= (at) counter_place)
      			)
      		:effect (is-on ?what)
      		; :observation (set_action (actionId turn_on))
      	) 
	

      	(:action fill
      		:parameters (?what - fill1 ?from - fill2  ?to - fill3)
      		; :duration (fill (objectId ?what) (objectId ?from) (objectId ?to))
      		:precondition (and 
               ; (fill-triple ?what ?from ?to)
      			(not (= ?from ?to))
      			(or 
      				(= (is-at ?from) hands)
                  (= ?from tap)
                  (= ?from peanut_butter_glass)
                  (= ?from jam_glass)
      			)
      			(or 
                  (= (is-at ?to) hands)
                  (and (= ?to bowl) (= (is-at bowl) counter))
                  (and (= ?to measuring_cup_s) (= (is-at measuring_cup_s) counter))
                  (and (= ?to baking_pan) (or
                     (= (is-at baking_pan) counter)
                     (= (is-at baking_pan) board))
                  )
                  (and 
                     (= ?to bread)
                     (or 
                        (>= (is-at-num bread plate) 1)
                        (>= (is-at-num bread board) 1)
                     )
                     (or 
                        (= (is-at knife) hands)
                        (and (= (is-at spoon) hands)(= ?what jam))
                     )
                  )
      			)
      			(or 
      ;                (and ; brownie recipe
      ;                (= ?to baking_pan)
      ; ;               (in butter ?to)
      ;                (= ?what dough)
      ;                (= bowl ?from)
      ;                (stired ?from)
      ;                (in brownie_mix ?from)
      ;                (in water ?from)
      ;                (in oil ?from)
      ;                (= (in-num egg ?from) 2))
      				(in ?what ?from)
      			)
      		)
      		:effect (and 
      			(in ?what ?to)
      			(not (in ?what ?from))
      			(not (stired ?to))
      			(not (is-clean hands))
               ; (when (and (= ?what dough) (= ?from bowl) (= ?to baking_pan)) (not (is-clean bowl)))
      			)
      		; :observation (set_action (actionId fill))
      		)
		
      		(:action fill
      			:parameters (?what - pfill1 ?from - fill2  ?to - fill3 ?how - part)
      			; :duration (fill (objectId ?what) (objectId ?from) (objectId ?to))
      			:precondition (and 
                  ; (fill-triple ?what ?from ?to)
      				(not (= ?from ?to))
      				(or 
      					(= (is-at ?from) hands)
      					(= ?from tap)
                     (= ?from peanut_butter_glass)
                     (= ?from jam_glass)
      				)
      				(or 
      					(= (is-at ?to) hands)
      					(and (= ?to bowl) (= (is-at bowl) counter))
      					(and (= ?to measuring_cup_s) (= (is-at measuring_cup_s) counter))
      					(and (= ?to baking_pan) (or 
      						(= (is-at baking_pan) counter)
      						(= (is-at baking_pan) board))
      					)
                     (and 
                        (= ?to bread)
                        ;(>= (is-at-num bread plate) 1)
                        (or 
                           (= (is-at knife) hands)
                           (and (= (is-at spoon) hands)(= ?what jam))
                        )
                     )
      				)
      				(or 
      					(and
      					(= ?what dough)
      					(= bowl ?from)
      					(stired ?from)
      					(in brownie_mix ?from)
      					(in water ?from)
      					(in oil ?from)
      					(= (in-num egg ?from) 2))
      					(in ?what ?from)
      				)
      			)
      			:effect (and 
      				(partially-in ?what ?to)
      				(not (stired ?to))
      				(not (is-clean hands))
      				)
      			; :observation (set_action (actionId fill))
      			)
			
			
      		(:action fill
      			:parameters (?what - cfill1 ?from - cofill2 ?to - fill3)
      			; :duration (fill (objectId ?what) (objectId ?from) (objectId ?to))
      			:precondition (and 
                  ; (fill-triple ?what ?from ?to)
      				(is-in ?what ?from)
      				(>= (is-at-num ?from hands) 1)
      				)
      			:effect (and
      				(decrease (is-at-num ?from hands) 1)
      				(increase (is-at-num (empty-of ?from) hands) 1)
      				(increase (in-num ?what ?to) 1)
      				(not (stired ?to))
      				(not (is-clean hands))
      				)
      			; :observation (set_action (actionId fill))
      			)
			
      	(:action clean
      		:parameters (?what - clean1 ?with - clean2)
      		; :duration (clean (objectId ?what) (objectId ?with))
      		:precondition (and 
      			(or
      					(imply (= ?with towel) (= (is-at ?with) hands))
      					(imply (= ?with paper_towel)(>= (is-at-num paper_towel hands) 1))
      				)
      				(not (is-clean ?what))
      				)
      		:effect (and
      			(is-clean ?what))
      		; :observation (set_action (actionId clean))
      		)
		
      		(:action clean
      			:parameters (?what - clean1 ?with - clean2 ?how - part)
      			; :duration (clean (objectId ?what) (objectId ?with))
      			:precondition (and 
      				(or
      						(imply (= ?with towel) (= (is-at ?with) hands))
      						(imply (= ?with paper_towel)(>= (is-at-num paper_towel hands) 1))
      					)
      					(not (is-clean ?what))
      					)
      			:effect (and
      				(partially-is-clean ?what))
      			; :observation (set_action (actionId clean))
      			)
		
         ; (:action stir
        ;             :parameters (?where - stir1 ?with - stir2)
        ;             ; :duration (stir (objectId ?where) (objectId ?with))
        ;             :precondition (and
        ;                (=(is-at ?with) hands)
        ;                (or
        ;                (=(is-at ?where) hands)
        ;                (=(is-at ?where) counter)
        ;                )
        ;                (not (stired ?where))
        ;                )
        ;             :effect (and
        ;                (stired ?where)
        ;                (not (is-clean hands)))
        ;             ; :observation (set_action (actionId stir))
        ;             )

         ; (:action stir
         ;    :parameters (?where - stir1 ?with - stir2 ?how - part)
         ;    ; :duration (stir (objectId ?where) (objectId ?with))
         ;    :precondition (and
         ;       (=(is-at ?with) hands)
         ;       (or
         ;       (=(is-at ?where) hands)
         ;       (=(is-at ?where) counter)
         ;       )
         ;       (not (stired ?where))
         ;       )
         ;    :effect (and
         ;       (partially-stired ?where))
         ;    ; :observation (set_action (actionId stir))
         ;    )
		
            (:action shake
                     :parameters (?what - shake1)
                     ; :duration (shake (objectId ?what))
                     :precondition (and
                        (= (is-at ?what) hands)
                        (< (shaken ?what) 3))
                     :effect (increase (shaken ?what) 1)
                     ; :observation (set_action (actionId shake))
            )
            
            (:action cut
               :parameters (?howmany - (number 1) ?what - cut1 ?with - cut2)
               :precondition (and 
                     (= (is-at ?with) hands)
                     (= (is-at-num ?what plate) ?howmany)
                     )
               :effect (and
                  (decrease (is-at-num ?what plate) ?howmany)
                  (increase (is-at-num (cut-of ?what) plate) ?howmany)
                  )
            )


	
      	(:action other
      		:irrational
      		:parameters ()
      		; :duration (other)
      		:precondition ()
      		:effect() 
      		; :observation (set_action (actionId other))
      	)
	
      	(:action finish
      		:irrational
      		:parameters()
      		:precondition (not finished)
      		:effect (finished)
      	)
      )
