(define (problem sandwich-default)
    (:domain sandwich)
    (:objects)
    (:init
		 
		 (= (objectId cupboard_tr) 1)
		 (= (objectId cupboard_tl) 2)
		 (= (objectId cupboard_br) 3)
		 (= (objectId cupboard_tm) 4)
		 (= (objectId fridge) 5)
		 (= (objectId oven) 6)
		 (= (objectId egg_box) 7)
		 (= (objectId brownie_box) 8)
		 (= (objectId drawer) 9)
		 (= (objectId egg_shell) 10)
		 (= (objectId cupboard_bl) 11)
		 (= (objectId oil_bottle) 12)
		 (= (objectId butter_spray_can) 13)
		 (= (objectId garbage) 14)
		 (= (objectId brownie_bag) 15)
		 (= (objectId croutons_bag) 16)
		 (= (objectId measuring_cup_s) 17)
		 (= (objectId measuring_cup_l) 18)
		 (= (objectId oil_bottle_cap) 19)
		 (= (objectId baking_pan) 20)
		 (= (objectId bowl) 21)
		 (= (objectId whisk) 22)
		 (= (objectId fork) 23)
		 (= (objectId spoon) 24)
		 (= (objectId counter) 25)
		 (= (objectId sink) 26)
		 (= (objectId towel) 27)
		 (= (objectId board) 28)
		 (= (objectId knife) 29)
		 (= (objectId butter_spray_cap) 30)
		 (= (objectId scissors) 31)
		 (= (objectId spatula) 32)
 		 (= (objectId empty_egg_shell) 33)
 		 (= (objectId paper_towel) 34)
 		 (= (objectId counter_place) 35)
 		 (= (objectId fridge_place) 36)
 		 (= (objectId egg) 37)
  		 (= (objectId open_egg_shell) 38)
  		 (= (objectId water) 39)
  		 (= (objectId tap) 40)
  		 (= (objectId brownie_mix) 41)
  		 (= (objectId oil) 42)
  		 (= (objectId butter) 43)
  		 (= (objectId dough) 44)
  		 (= (objectId hands) 45)
		 
		 
       ; "", "take", "put", "turn_on", "fill", "open", "close", "stir", "shake", "clean", "other"
		 (= (actionId walk) 0)
		 (= (actionId take) 1)
		 (= (actionId put) 2)
		 (= (actionId turn_on) 3)
		 (= (actionId fill) 5)
		 (= (actionId open) 6)
		 (= (actionId close) 7)
		 (= (actionId stir) 8)
		 (= (actionId shake) 9)
		 (= (actionId clean) 10)
		 (= (actionId other) 11)
		
		;combined objects
		;combined objects
		(= (first jam_glass&peanut_butter_glass) jam_glass)
		(= (second jam_glass&peanut_butter_glass) peanut_butter_glass)

		(= (first peanut_butter_glass&peanut_butter_glass_cap) peanut_butter_glass)
		(= (second peanut_butter_glass&peanut_butter_glass_cap) peanut_butter_glass_cap)

		(= (first knife&spoon) knife)
		(= (second knife&spoon) spoon)

      (= (first paper_towel&knife) paper_towel)
      (= (second paper_towel&knife) knife)

      (= (first peanut_butter_glass&bread_bag) peanut_butter_glass)
      (= (second peanut_butter_glass&bread_bag) bread_bag)

      (= (first jam_glass&jam_glass_cap) jam_glass)
      (= (second jam_glass&jam_glass_cap) jam_glass_cap)
	
   
   
     
   
;grep "(take \|(put " Data/*.txt | cut -d"," -f3 | sort | uniq | sed 's/put/take/' | sed 's/take/take-pair/' | sort | uniq
	
   (= (cut-of sandwich) cut_sandwich)
   (= (fold-of bread) sandwich)

	   ; (= (open-of egg_shell) open_egg_shell)
   ;    (= (empty-of open_egg_shell) empty_egg_shell)
   ;    (is-in egg open_egg_shell)
   ;
   ;
   ;    (in water tap)
   ;    (in brownie_mix brownie_bag)
   ;    (in oil oil_bottle)
   ;    (in butter butter_spray_can)
   ;    (is-clean hands)
   ;    (is-clean bowl)
   ;    (not (is-clean spoon))
   ;
   ;    ;fluents
       (= (at) counter_place)
   ;    (= (is-at-num egg_shell egg_box) 2)
   ;    (= (is-at-num paper_towel counter) 2)
         
   ;
   ;    ; object location
   ;    (= (is-at egg_box) fridge)
   ;    (= (is-at brownie_bag) brownie_box)
   ;    (= (is-at croutons_bag) cupboard_br)
   ;    (= (is-at towel) counter)
   ;    (= (is-at measuring_cup_s) cupboard_tr)
   ;    (= (is-at measuring_cup_l) cupboard_tr)
   ;    (= (is-at fork) drawer)
   ;    (= (is-at knife) drawer)
   ;    (= (is-at whisk) drawer)
   ;    (= (is-at oil_bottle_cap) oil_bottle)
   ;    (= (is-at butter_spray_cap) butter_spray_can)
   ;    (= (is-at scissors) drawer)
   ;    (= (is-at spoon) drawer)
   ;    (= (is-at spatula) drawer)
   ;    (= (is-at board) counter)
   ;    (= (objects_taken) 0)
   ; (= (is-at clip) bread_bag)

   (= (is-at knife) drawer)
   (= (is-at peanut_butter_glass) fridge)
   (= (is-at jam_glass) fridge)
   (= (is-at jam_glass_2) fridge)
   (= (is-at-num bread bread_bag) 2)
   (in peanut_butter peanut_butter_glass)
   (in jam jam_glass)
   (= (is-at-num paper_towel fridge_counter) 1)
   (= (is-at spoon) drawer)
   (= (is-at peanut_butter_glass_cap) peanut_butter_glass)
   (= (is-at jam_glass_cap) jam_glass)
   (= (is-at board) counter)
   

   ;
; (is-at knife drawer)
; (is-at jam_glass fridge)
; (is-at jam_glass_2 fridge)
; (is-at peanut_butter_glass fridge)
; (is-at clip bread_bag)
; (is-at bread_1 bread_bag)
; (is-at bread_2 bread_bag)
;
; (is-at bowl cupboard_tr)
; (is-at measuring_cup_s cupboard_tr)
; (is-at measuring_cup_l cupboard_tr)
; (is-at fork drawer)
; (is-at egg_shell_1 egg_box)
; (is-at egg_shell_2 egg_box)
; (is-at egg_box )
; (is-at towel counter)
; (is-at pepper_shaker cupboard_tl)
; (is-at salt_shaker cupboard_tl)
; (is-at pan cupboard_bl)
;
; (is-at brownie_box cupboard_tl)
; (in water tap)
; (is-at oil_bottle cupboard_br)
; (is-at butter_spray_can cupboard_br)
; (in oil oil_bottle)
;
; (is-at brownie_bag brownie_box)
;
; (is-at baking_pan cupboard_bl)
; (is-at paper_towel counter)
;
;
; (is-at scissors drawer)
; (is-at spoon drawer)
;

(= (is-at bread_bag) fridge)
(= (is-at plate) cupboard_tl)
(= (is-at clip) bread_bag)	
    )
	
	(:goal
		finished
	)
)
